// =============================================================================
// Copyright (C) MACNICA inc.
// =============================================================================
// FILE NAME	: Video_BRR_Audio_Loopback_top.v
// DEPARTMENT	: MACNICA Strategic Technology Group
// AUTHOR		: Ryosuke Yamamoto
// DATE 		: 07/22/2014
// =============================================================================
// DESCRIPTION	:
//		
// =============================================================================
// REVISION HISTORY :
//		v1.0		: Initial Release
//
// =============================================================================
// PARAMETERS	:
//
// =============================================================================
// I/O PORTS	:
//
//
// =============================================================================
`timescale 1ps/1ps
`default_nettype none

module Video_BRR_Audio_Loopback_top (
// REF CLOCK IN =========================================//
	REFCLK_L0_P				,	//(Default:100MHz,if S1=on frSMA )
//	REFCLK_148M_P			,
//	REFCLK_125M_Pi			,
// CLOCK IN =============================================//
	CLKIN_DDR3_50M_TOP_i	,
	CLKIN_DDR3_50M_BOT_i	,
//	CLKIN_100M				,
	CLKIN_74p25M_i			,
	CLKIN_27M_i				,
// USER SW ==============================================//
	USER_PB_i				,
	USER_DIP_i				,
// USER LED =============================================//
	USER_LED_o				,
// USER-GPIO ============================================//
	USER_GPIO_o					,

// HSMC PORT-A ==========================================//
	DP_CLK_i					,
	AUDIO_CLK_i					,

	HD_BCK_i					,
	HD_BVD_i					,
	HD_BHD_i					,
	HD_BDEN_i					,
	HD_Y_i						,
	HD_UV_i						,
	HD_EXTRST_o					,
	HD_PWDN_o					,
	HD_SCL_io					,
	HD_SDA_io					,

	AUD_MCLK_o					,
	AUD_BCLK_io					,
	AUD_LRCLK_io				,
	AUD_DACDAT_o				,
	AUD_ADCDAT_i				,
	AUD_SCL_io					,
	AUD_SDA_io					,

	DP_TX_SERIALDATA_o			,
	DP_CONFIG1_o				,
	DP_CONFIG2_o				,
	DP_HPD_i					,
	DP_AUX_D_i					,
	DP_AUX_D_o					,
	DP_AUX_DIR_o				,
	DP_AUX_o					,

	ENET_RESET_no				,
	ENET_RGMII_GTX_CLK_o		,
	ENET_MDC_o					,
	ENET_MDIO_io				,
	ENET_RGMII_RX_CLK_i			,
	ENET_RGMII_RX_DV_i			,
	ENET_RGMII_RXD_i			,	// [ 3:0]
	ENET_RGMII_TX_EN_o			,
	ENET_RGMII_TXD_o			,	// [ 3:0]
	ENET_810SYNC_i				,
	ENET_LED_io					,
	ENET_811SYNC_i				,
	ENET_811SYNC_o				,
	ENET_WAKE_i					,
	ENET_EN_i					,
	ENET_PSDET_i				,

// HSMC PORT-B ==========================================//
	VOUT_PCLK_o					,
	VOUT_HSYNC_o				,
	VOUT_VSYNC_o				,
	VOUT_DE_o					,
	VOUT_DATA_o					,
	// DVI setting
	DVI_ISEL_o					,
	DVI_DKEN_o					,
	DVI_CTL1_o					,
	DVI_CTL2_o					,
	DVI_CTL3_o					,
	DVI_PD_o					,
	DVI_SCL_BSEL_io				,
	DVI_SDA_DSEL_io				,

// DDR3 x32 TOP =========================================//
	DDR3_x32_TOP_A_o			,
	DDR3_x32_TOP_BA_o			,
	DDR3_x32_TOP_CK_o			,
	DDR3_x32_TOP_CK_no			,
	DDR3_x32_TOP_CKE_o			,
	DDR3_x32_TOP_CS_no			,
	DDR3_x32_TOP_DM_o			,
	DDR3_x32_TOP_RAS_no			,
	DDR3_x32_TOP_CAS_no			,
	DDR3_x32_TOP_WE_no			,
	DDR3_x32_TOP_RESET_no		,
	DDR3_x32_TOP_DQ_io			,
	DDR3_x32_TOP_DQS_io			,
	DDR3_x32_TOP_DQS_nio		,
	DDR3_x32_TOP_ODT_o			,
	DDR3_x32_TOP_OCT_RZQIN_i	,
// DDR3 x64 TOP =========================================//
	DDR3_x64_BOT_A_o			,
	DDR3_x64_BOT_BA_o			,
	DDR3_x64_BOT_CK_o			,
	DDR3_x64_BOT_CK_no			,
	DDR3_x64_BOT_CKE_o			,
	DDR3_x64_BOT_CS_no			,
	DDR3_x64_BOT_DM_o			,
	DDR3_x64_BOT_RAS_no			,
	DDR3_x64_BOT_CAS_no			,
	DDR3_x64_BOT_WE_no			,
	DDR3_x64_BOT_RESET_no		,
	DDR3_x64_BOT_DQ_io			,
	DDR3_x64_BOT_DQS_io			,
	DDR3_x64_BOT_DQS_nio		,
	DDR3_x64_BOT_ODT_o			,
	DDR3_x64_BOT_OCT_RZQIN_i	
) ;
	
// =============================================================================
// PARAMETER DEFINITION
// =============================================================================

	// ---------------------------------------------------------------------
	// Below parameters have to be defined from upper module
	// ---------------------------------------------------------------------
	parameter	CNT_MAX		= 20'h3_0000 ;
	parameter	ENET_RATE	= 1 ;			// 0:10Mbps 1:100Mbps 2:1Gbps
	parameter	LANES		= 4 ;
	parameter	TX_SYMBOLS_PER_CLOCK	= 2 ;
	parameter	RX_SYMBOLS_PER_CLOCK	= 2 ;
	parameter	TX_POLINV	= 0 ;
	parameter	RX_POLINV	= 1 ;
	// ---------------------------------------------------------------------
	// Please do not change the following parameters
	// ---------------------------------------------------------------------

// =============================================================================
// PORT DECLARATION
// =============================================================================
// REF CLOCK IN =========================================//
	input	wire	[  1 : 1 ]	REFCLK_L0_P				;	//(Default:100MHz,if S1=on frSMA )
//	input	wire				REFCLK_148M_P			;
//	input	wire				REFCLK_125M_Pi			;
// CLOCK IN =============================================//
	input	wire				CLKIN_DDR3_50M_TOP_i	;
	input	wire				CLKIN_DDR3_50M_BOT_i	;
//	input	wire				CLKIN_100M				;
	input	wire				CLKIN_74p25M_i			;
	input	wire				CLKIN_27M_i				;
// USER SW ==============================================//
	input	wire	[  2 : 0 ]	USER_PB_i				;
	input	wire	[  1 : 0 ]	USER_DIP_i				;
// USER LED =============================================//
	output	wire	[  3 : 0 ]	USER_LED_o				;
// USER-GPIO ============================================//
	inout	wire	[  5 : 0 ]	USER_GPIO_o					;

// HSMC PORT-A ==========================================//
	// BroadR-Reach Card ( HSMC Port A )
	input	wire				DP_CLK_i					;
	input	wire				AUDIO_CLK_i					;

	input	wire				HD_BCK_i					;
	input	wire				HD_BVD_i					;
	input	wire				HD_BHD_i					;
	input	wire				HD_BDEN_i					;
	input	wire	[  7 : 0 ]	HD_Y_i						;
	input	wire	[  7 : 0 ]	HD_UV_i						;
	output	wire				HD_EXTRST_o					;
	output	wire				HD_PWDN_o					;
	inout	wire				HD_SCL_io					;
	inout	wire				HD_SDA_io					;

	output	wire				AUD_MCLK_o					;
	inout	wire				AUD_BCLK_io					;
	inout	wire				AUD_LRCLK_io				;
	output	wire				AUD_DACDAT_o				;
	input	wire				AUD_ADCDAT_i				;
	inout	wire				AUD_SCL_io					;
	inout	wire				AUD_SDA_io					;

//	output	wire				DP_TX0_o					;
//	output	wire				DP_TX1_o					;
//	output	wire				DP_TX2_o					;
//	output	wire				DP_TX3_o					;
	output	wire	[  3 : 0 ]	DP_TX_SERIALDATA_o			;
	output	wire				DP_CONFIG1_o				;
	output	wire				DP_CONFIG2_o				;
	input	wire				DP_HPD_i					;
	input	wire				DP_AUX_D_i					;
	output	wire				DP_AUX_D_o					;
	output	wire				DP_AUX_DIR_o				;
	output	wire				DP_AUX_o					;

	output	wire				ENET_RESET_no				;
	output	wire				ENET_RGMII_GTX_CLK_o		;
	output	wire				ENET_MDC_o					;
	inout	wire				ENET_MDIO_io				;
	input	wire				ENET_RGMII_RX_CLK_i			;
	input	wire				ENET_RGMII_RX_DV_i			;
	input	wire	[  3 : 0 ]	ENET_RGMII_RXD_i			;	// [ 3:0]
	output	wire				ENET_RGMII_TX_EN_o			;
	output	wire	[  3 : 0 ]	ENET_RGMII_TXD_o			;	// [ 3:0]
	input	wire				ENET_810SYNC_i				;
	inout	wire	[  4 : 1 ]	ENET_LED_io					;
	input	wire				ENET_811SYNC_i				;
	output	wire				ENET_811SYNC_o				;
	input	wire				ENET_WAKE_i					;
	input	wire				ENET_EN_i					;
	input	wire				ENET_PSDET_i				;

// HSMC PORT-B ==========================================//
	output	wire				VOUT_PCLK_o					;
	output	wire				VOUT_HSYNC_o				;
	output	wire				VOUT_VSYNC_o				;
	output	wire				VOUT_DE_o					;
	output	wire	[ 23 : 0 ]	VOUT_DATA_o					;
	// DVI setting
	output	wire				DVI_ISEL_o					;
	output	wire				DVI_DKEN_o					;
	output	wire				DVI_CTL1_o					;
	output	wire				DVI_CTL2_o					;
	output	wire				DVI_CTL3_o					;
	output	wire				DVI_PD_o					;
	inout	wire				DVI_SCL_BSEL_io				;
	inout	wire				DVI_SDA_DSEL_io				;

// DDR3 x32 TOP =========================================//
	output	wire 	[ 12 : 0 ]	DDR3_x32_TOP_A_o			;
	output	wire 	[  2 : 0 ]	DDR3_x32_TOP_BA_o			;
	output	wire 				DDR3_x32_TOP_CK_o			;
	output	wire 				DDR3_x32_TOP_CK_no			;
	output	wire 				DDR3_x32_TOP_CKE_o			;
	output	wire 				DDR3_x32_TOP_CS_no			;
	output	wire 	[  3 : 0 ]	DDR3_x32_TOP_DM_o			;
	output	wire 				DDR3_x32_TOP_RAS_no			;
	output	wire 				DDR3_x32_TOP_CAS_no			;
	output	wire 				DDR3_x32_TOP_WE_no			;
	output	wire 				DDR3_x32_TOP_RESET_no		;
	inout	wire 	[ 31 : 0 ]	DDR3_x32_TOP_DQ_io			;
	inout	wire 	[  3 : 0 ]	DDR3_x32_TOP_DQS_io			;
	inout	wire 	[  3 : 0 ]	DDR3_x32_TOP_DQS_nio		;
	output	wire 				DDR3_x32_TOP_ODT_o			;
	input	wire				DDR3_x32_TOP_OCT_RZQIN_i	;
// DDR3 x64 TOP =========================================//
	output	wire 	[ 12 : 0 ]	DDR3_x64_BOT_A_o			;
	output	wire 	[  2 : 0 ]	DDR3_x64_BOT_BA_o			;
	output	wire 	[  1 : 0 ]	DDR3_x64_BOT_CK_o			;
	output	wire 	[  1 : 0 ]	DDR3_x64_BOT_CK_no			;
	output	wire 				DDR3_x64_BOT_CKE_o			;
	output	wire 				DDR3_x64_BOT_CS_no			;
	output	wire 	[  7 : 0 ]	DDR3_x64_BOT_DM_o			;
	output	wire 				DDR3_x64_BOT_RAS_no			;
	output	wire 				DDR3_x64_BOT_CAS_no			;
	output	wire 				DDR3_x64_BOT_WE_no			;
	output	wire 				DDR3_x64_BOT_RESET_no		;
	inout	wire 	[ 63 : 0 ]	DDR3_x64_BOT_DQ_io			;
	inout	wire 	[  7 : 0 ]	DDR3_x64_BOT_DQS_io			;
	inout	wire 	[  7 : 0 ]	DDR3_x64_BOT_DQS_nio		;
	output	wire 				DDR3_x64_BOT_ODT_o			;
	input	wire				DDR3_x64_BOT_OCT_RZQIN_i	;


// =============================================================================
// REG / WIRE DECLARATION
// =============================================================================

	wire				clk_100m					;
	wire				clk_10m						;
	wire				clk_125m					;
	wire				clk_25m						;
	wire				clk_2p5m					;
	wire				pll_sys_locked				;
	wire				clk_audio					;
	wire				pll_bclk					;
	wire				pll_audio_locked			;
	wire				enet_rgmii_rx_clk			;
	wire				xcvr_pll_refclk				;
	wire				clk162						;
	wire				xcvr_pll_locked_162			;
	wire				clk270						;
	wire				xcvr_pll_locked_270			;
	wire	[  1 : 0 ]	xcvr_refclk					;
	wire				rx_clk_45					;
	wire				rx_clk_90					;
	wire				rx_clk_135					;
	wire				rx_clk_180					;
	wire				pll_enet_locked				;

	reg		[ 15 : 0 ]	chat_cnt_ff					;
	reg					pll_locked1_ff				;
	reg					pll_locked2_ff				;
	reg					pll_locked3_ff				;
	reg					rst_nff						;
	wire				reset_n						;

	reg					srst_ff						;
	reg		[ 19 : 0 ]	counter_ff					;

	reg		[  2 : 0 ]	pb_lat1_ff					;
	reg		[  2 : 0 ]	pb_lat2_ff					;
	reg		[  2 : 0 ]	pb_lat3_ff					;
	reg		[  2 : 0 ]	pb_ff						;

	reg		[ 1 : 0 ]	clk_cnt_ff					;
	reg					bclk_ff						;
	wire				bclk						;
	reg		[ 4 : 0 ]	audio_data_cnt_ff			;
	wire				audio_ws					;
	wire				aud_scl						;
	wire				aud_scl_en					;
	wire				aud_sda						;
	wire				aud_sda_en					;
	wire				aud_init_end				;

	wire				enet_rx_clk					;
	wire				enet_tx_clk					;
	wire				enet_mdio_out				;
	wire				enet_mdio_oen				;
	wire				mac_status_set_10			;
	wire				mac_status_set_1000			;
	wire				mac_status_eth_mode			;
	wire				mac_status_ena_10			;
	wire				mac_misc_tx_ff_uflow		;
	wire				mac_misc_ff_tx_a_full		;
	wire				mac_misc_ff_tx_a_empty		;

	wire	[ 15 : 0 ]	hd_yuv						;

	wire				video_out_vid_clk			;
	wire	[ 23 : 0 ]	video_out_vid_data			;
	wire				video_out_underflow			;
	wire				video_out_vid_datavalid		;
	wire				video_out_vid_v_sync		;
	wire				video_out_vid_h_sync		;
	wire				video_out_vid_f				;
	wire				video_out_vid_h				;
	wire				video_out_vid_v				;

	reg					vout_vsync_ff				;
	reg					vout_hsync_ff				;
	reg					vout_de_ff					;
	reg		[ 23 : 0 ]	vout_data_ff				;

	wire	[  3 : 0 ]	as_core_led_export			;
	wire	[ 95 : 0 ]	as_core_time				;

	wire	[  7 : 0 ] 	qsys_pio					;

	// Connections from DP core to the reconfig management FSM
	wire	[  1 : 0 ]	tx_link_rate				;
	wire				tx_reconfig_req				;
	wire				tx_reconfig_ack				;
	wire				tx_reconfig_busy			;

	// Connections from the reconfig management FSM to the XCVR reconfig IP
	wire				mgmt_waitrequest			;
	wire	[  6 : 0 ]	mgmt_address				;
	wire	[ 31 : 0 ]	mgmt_writedata				;
	wire				mgmt_write					;
	wire				reconfig_busy				;

	// Connections from DP to the reconfig IP
	wire	[ 559 : 0 ]	reconfig_to_xcvr			;
	wire	[ 367 : 0 ]	reconfig_from_xcvr			;

	// Connections between DP and PHY
	wire	[ LANES*10*TX_SYMBOLS_PER_CLOCK-1:0]	tx_parallel_data	;
	wire	[ LANES-1 : 0 ]	tx_serial_data			;
	wire	[ LANES-1 : 0 ]	tx_pll_powerdown		;
	wire	[ LANES-1 : 0 ]	tx_analogreset			;
	wire	[ LANES-1 : 0 ]	tx_digitalreset			;
	wire	[ LANES-1 : 0 ]	tx_cal_busy				;
	wire	[ LANES-1 : 0 ]	tx_std_clkout			;
	wire	[ LANES-1 : 0 ]	tx_pll_locked			;


// =============================================================================
// FUNCTION DESCRIPTION
// =============================================================================

	//=======//
	// Clock //
	//=======//
	pll_sys	
		u_pll_sys (
			.rst		( ~USER_PB_i[0]			) ,
			.refclk		( CLKIN_DDR3_50M_TOP_i	) ,
			.outclk_0	( clk_100m				) ,		// 100MHz
			.outclk_1	( clk_10m				) ,		// 10MHz
			.outclk_2	( clk_125m				) ,		// 125MHz
			.outclk_3	( clk_25m				) ,		// 25MHz
			.outclk_4	( clk_2p5m				) ,		// 2.5MHz
			.locked		( pll_sys_locked		) 
		) ;

	assign	xcvr_pll_refclk	= REFCLK_L0_P[1] ;

	cv_pll_162 
		xcvr_pll_162_inst (
			.refclk		( xcvr_pll_refclk		) ,
			.rst		( ~USER_PB_i[0]			) ,    
			.outclk_0	( clk162				) ,
			.locked		( xcvr_pll_locked_162	) 
		);

	cv_pll_270 
		xcvr_pll_270_inst (
			.refclk		( xcvr_pll_refclk		) ,
			.rst		( ~USER_PB_i[0]			) ,    
			.outclk_0	( clk270				) ,
			.locked		( xcvr_pll_locked_270	) 
		);

	assign	xcvr_refclk[0]	= clk162;
	assign	xcvr_refclk[1]	= clk270;

//	clk_ctl 
//		u_enet_rx_clk (
//			.inclk  ( ENET_RGMII_RX_CLK_i	) ,	//  altclkctrl_input.inclk
//			.outclk ( enet_rgmii_rx_clk		)	// altclkctrl_output.outclk
//		);
//
//	pll_enet_rx
//		u_pll_enet_rx (
//			.rst		( ~USER_PB_i[1]			) ,
//			.refclk		( enet_rgmii_rx_clk		) ,
//			.outclk_0	( rx_clk_45				) ,		// 
//			.outclk_1	( rx_clk_90				) ,		// 
//			.outclk_2	( rx_clk_135			) ,		// 
//			.outclk_3	( rx_clk_180			) ,		// 
//			.locked		( pll_enet_locked		) 
//		) ;

	pll_audio
		u_pll_audio (
			.rst		( ~USER_PB_i[0]		) ,
			.refclk		( AUDIO_CLK_i		) ,		// 24.576MHz
			.outclk_0	( clk_audio			) ,		// 12.288MHz
			.outclk_1	( pll_bclk			) ,		//  1.536MHz
			.locked		( pll_audio_locked	) 
		) ;


	//=======//
	// Reset //
	//=======//
	always @ ( posedge clk_10m or negedge USER_PB_i[0] ) begin
		if ( !USER_PB_i[0] ) begin
			chat_cnt_ff	<= 16'hFFFF ;
			pll_locked1_ff	<= 1'b0 ;
			pll_locked2_ff	<= 1'b0 ;
			pll_locked3_ff	<= 1'b0 ;
			rst_nff			<= 1'b0 ;
		end
		else begin
			chat_cnt_ff	<= chat_cnt_ff - 1'b1 ;
			if ( chat_cnt_ff == 16'h0000 ) begin
				pll_locked1_ff	<= pll_sys_locked & pll_audio_locked ;
//				pll_locked1_ff	<= 1'b1 ;
				pll_locked2_ff	<= pll_locked1_ff ;
				pll_locked3_ff	<= pll_locked2_ff ;
				if ( pll_locked1_ff && pll_locked2_ff && pll_locked3_ff ) begin
					rst_nff	<= 1'b1 ;
				end
			end
		end
	end

	assign	reset_n	= rst_nff ;

	always @ ( posedge CLKIN_74p25M_i or negedge reset_n ) begin
		if ( !reset_n ) begin
			srst_ff	<= 1'b1 ;
		end
		else begin
			if ( counter_ff == CNT_MAX ) begin
				srst_ff	<= 1'b0 ;
			end
		end
	end

	always @ ( posedge CLKIN_74p25M_i or negedge reset_n ) begin
		if ( !reset_n ) begin
			counter_ff	<= 20'h0_0000 ;
		end
		else begin
			if ( counter_ff == CNT_MAX ) begin
				counter_ff	<= 20'h0_0000 ;
			end
			else begin
				counter_ff	<= counter_ff + 1'b1 ;
			end
		end
	end


	//====================//
	// Chattering Removal //
	//====================//
	always @ ( posedge clk_10m or negedge reset_n ) begin
		if ( !reset_n ) begin
			pb_lat1_ff	<= 3'b111 ;
			pb_lat2_ff	<= 3'b111 ;
			pb_lat3_ff	<= 3'b111 ;
			pb_ff		<= 3'b111 ;
		end
		else begin
			pb_lat1_ff	<= USER_PB_i ;
			if ( chat_cnt_ff == 16'h0000 ) begin
				pb_lat2_ff	<= pb_lat1_ff ;
				pb_lat3_ff	<= pb_lat2_ff ;
				pb_ff[0]	<= ( pb_lat3_ff[0] == pb_lat2_ff[0] ) ?	pb_lat2_ff[0] : pb_ff[0] ;
				pb_ff[1]	<= ( pb_lat3_ff[1] == pb_lat2_ff[1] ) ?	pb_lat2_ff[1] : pb_ff[1] ;
				pb_ff[2]	<= ( pb_lat3_ff[2] == pb_lat2_ff[2] ) ?	pb_lat2_ff[2] : pb_ff[2] ;
			end
		end
	end


	//===========//
	// Audio I/F //
	//===========//
	always @ ( posedge clk_audio or negedge reset_n ) begin
		if ( !reset_n ) begin
			clk_cnt_ff	<= 2'b00 ;
			bclk_ff		<= 1'b0 ;
		end
		else begin
			clk_cnt_ff	<= clk_cnt_ff + 1'b1 ;
			if ( clk_cnt_ff == 2'b11 ) begin
				bclk_ff		<= ~bclk_ff ;
			end
		end
	end

//	assign bclk	= bclk_ff ;
	assign bclk	= pll_bclk ;

	always @ ( posedge clk_audio or negedge reset_n ) begin
		if ( !reset_n ) begin
			audio_data_cnt_ff	<= 5'h00 ;
		end
		else if ( bclk_ff && ( clk_cnt_ff == 2'b11 ) ) begin
			audio_data_cnt_ff	<= audio_data_cnt_ff + 1'b1 ;
		end
	end

	assign	audio_ws		= audio_data_cnt_ff[4] ;
	assign	AUD_MCLK_o		= clk_audio ;
	assign	AUD_BCLK_io		= bclk ;
	assign	AUD_LRCLK_io	= audio_ws ;
	assign	AUD_DACDAT_o	= AUD_ADCDAT_i ;
	
	// I2C Setting //
	i2c_ctl_wrp 
		u_i2c_ctl_wrp (
			.clk			( clk_audio		) ,
			.rst_n			( reset_n		) ,
			.srst			( 1'b0			) ,
			.i2cm_scl_i		( AUD_SCL_io	) ,
			.i2cm_scl_o		( aud_scl		) ,
			.i2cm_scl_en_o	( aud_scl_en	) ,
			.i2cm_sda_i		( AUD_SDA_io	) ,
			.i2cm_sda_o		( aud_sda		) ,
			.i2cm_sda_en_o	( aud_sda_en	) ,
			.init_end_o		( aud_init_end	) 
		) ;

	assign	AUD_SCL_io	= ( aud_scl_en && !aud_scl ) ?	1'b0 : 1'bZ ;
	assign	AUD_SDA_io	= ( aud_sda_en && !aud_sda ) ?	1'b0 : 1'bZ ;


	//============//
	// Sensor I/F //
	//============//
	assign	HD_EXTRST_o		= reset_n ;
	assign	HD_PWDN_o		= ~pb_ff[0] ;

	assign	hd_yuv	= { HD_Y_i , HD_UV_i } ;


	//=====================//
	// RGMII I/F & MAC I/F //
	//=====================//
	assign	enet_rx_clk				= ENET_RGMII_RX_CLK_i ;
	assign	enet_tx_clk				= ENET_RGMII_RX_CLK_i ;

	assign	mac_status_set_10		= 1'b0 ;
	assign	mac_status_set_1000		= 1'b0 ;

	assign	ENET_RESET_no	= reset_n ;
	assign	ENET_MDIO_io	= ( !enet_mdio_oen ) ?	enet_mdio_out	: 1'bZ ;

	ddio_out
		ddio_out_inst (
			.datain_h		( 1'b1					) ,
			.datain_l		( 1'b0					) ,
			.outclock		( enet_tx_clk			) ,
			.dataout		( ENET_RGMII_GTX_CLK_o	) 
		) ;


	//==============//
	// Display Port //
	//==============//
	assign	video_out_vid_clk	= CLKIN_74p25M_i ;

	always @ ( posedge video_out_vid_clk ) begin
		vout_vsync_ff	<= video_out_vid_v_sync ;
		vout_hsync_ff	<= video_out_vid_h_sync ;
		vout_de_ff		<= video_out_vid_datavalid ;
		vout_data_ff	<= video_out_vid_data ;
	end


    // Instantiate the TX PHY IP   
	genvar i;
	generate begin    
		for (i = 0; i < LANES; i = i + 1) begin : TX_PHY_GEN
			cv_native_phy_tx 
				u_tx_phy (
					.pll_powerdown				( tx_pll_powerdown[i]	) ,
					.tx_analogreset				( tx_analogreset[i]		) ,
					.tx_digitalreset			( tx_digitalreset[i]	) ,
					.tx_pll_refclk				( xcvr_refclk			) ,
					.tx_serial_data				( tx_serial_data[i]		) ,
					.pll_locked					( tx_pll_locked[i]		) ,
					.tx_std_coreclkin			( tx_std_clkout[0]		) ,
					.tx_std_clkout				( tx_std_clkout[i]		) ,
					.tx_std_polinv				( (TX_POLINV==1)		) ,
					.tx_cal_busy				( tx_cal_busy[i]		) ,
					.reconfig_to_xcvr			( {reconfig_to_xcvr[( (LANES*70)+(70*i) ) +: 70], reconfig_to_xcvr[(70*i) +: 70]}		) ,
					.reconfig_from_xcvr			( {reconfig_from_xcvr[( (LANES*46)+(46*i) ) +: 46], reconfig_from_xcvr[(46*i) +: 46]}	) ,
					.tx_parallel_data			( tx_parallel_data[10*TX_SYMBOLS_PER_CLOCK*i +: 10*TX_SYMBOLS_PER_CLOCK]				) ,
					.unused_tx_parallel_data	( 						)
				);
			end
		end
	endgenerate

	assign	DP_TX_SERIALDATA_o	= tx_serial_data ;

    // Instantiate the reconfig management FSM
	reconfig_mgmt_hw_ctrl 
		#(
			.DEVICE_FAMILY	("Cyclone V"),
			.RX_LANES		(0),
			.TX_LANES		(LANES),
			.TX_PLLS		(LANES)
		) mgmt (
			.clk						( xcvr_pll_refclk	),
			.reset						( !reset_n			),

			.tx_reconfig_req			( tx_reconfig_req	),
			.tx_link_rate				( tx_link_rate		),
			.tx_reconfig_ack			( tx_reconfig_ack	),
			.tx_reconfig_busy			( tx_reconfig_busy	),

        // Disable vod & emp for Bitec Rev 4+ daughter cards with re-drivers
			.tx_analog_reconfig_req		( 1'b0				),
			.vod						( 8'b00000000		),
			.emp						( 8'b00000000		),	
			.tx_analog_reconfig_ack		( 					), // unused
			.tx_analog_reconfig_busy	( 					), // unused

			.mgmt_address				( mgmt_address		),
			.mgmt_writedata				( mgmt_writedata	),
			.mgmt_write					( mgmt_write		),
			.mgmt_waitrequest			( mgmt_waitrequest	),
			.reconfig_busy				( reconfig_busy		)
		);

     // Instantiate the XCVR reconfig IP
	cv_xcvr_reconfig 
		reconfig (
			.reconfig_busy				( reconfig_busy			) ,
			.mgmt_clk_clk				( xcvr_pll_refclk		) ,
			.mgmt_rst_reset				( !reset_n				) ,
			.reconfig_mgmt_address		( mgmt_address			) ,
			.reconfig_mgmt_read			( 						) ,
			.reconfig_mgmt_readdata		( 						) ,
			.reconfig_mgmt_waitrequest	( mgmt_waitrequest		) ,
			.reconfig_mgmt_write		( mgmt_write			) ,
			.reconfig_mgmt_writedata	( mgmt_writedata		) ,
			.reconfig_to_xcvr			( reconfig_to_xcvr		) ,
			.reconfig_from_xcvr			( reconfig_from_xcvr	)  
		);


	//==============//
	// DVI I/F      //
	// Nitro Port B //
	//==============//
	assign	VOUT_PCLK_o		= video_out_vid_clk ;
	assign	VOUT_VSYNC_o	= vout_vsync_ff ;
	assign	VOUT_HSYNC_o	= vout_hsync_ff ;
	assign	VOUT_DE_o		= vout_de_ff ;
	assign	VOUT_DATA_o		= vout_data_ff ;

	assign	DVI_ISEL_o		= 1'b0 ;
	assign	DVI_DKEN_o		= 1'b1 ;
	assign	DVI_CTL1_o		= qsys_pio[2] ;
	assign	DVI_CTL2_o		= qsys_pio[1] ;
	assign	DVI_CTL3_o		= qsys_pio[0] ;
	assign	DVI_PD_o		= 1'b1 ;
	assign	DVI_SCL_BSEL_io	= 1'b1 ;
	assign	DVI_SDA_DSEL_io	= 1'b1 ;


	//==============//
	// Other signal //
	//==============//
	assign	USER_GPIO_o[5]	= 1'b0 ;
	assign	USER_GPIO_o[4]	= 1'b0 ;
	assign	USER_GPIO_o[3]	= 1'b0 ;
	assign	USER_GPIO_o[2]	= 1'b0 ;
	assign	USER_GPIO_o[1]	= 1'b0 ;
	assign	USER_GPIO_o[0]	= 1'b0 ;


	//============//
	// Qsys Block //
	//============//
	Video_BRR_Audio_Loopback_system 
		u0 (
			.clk_50top_clk                     	( CLKIN_DDR3_50M_TOP_i		) ,	//            clk_50top.clk
			.reset_reset_n                     	( reset_n					) ,	//                reset.reset_n
			.clk_50btm_clk                     	( CLKIN_DDR3_50M_BOT_i		) ,	//            clk_50btm.clk
			.clk_100_clk                       	( xcvr_pll_refclk			) ,	//              clk_100.clk
			.clk_aux_clk                       	( DP_CLK_i					) ,	//              clk_aux.clk

			.dip_sw_export                     	( USER_DIP_i				) ,	//               dip_sw.export
			.led_export                        	( USER_LED_o				) ,	//                  led.export
			.push_sw_export                    	( pb_ff						) ,	//              push_sw.export
			.pio_export                        	( qsys_pio					) ,	//                  pio.export

			.ddr3_32mem_mem_a                  	( DDR3_x32_TOP_A_o			) ,	//           ddr3_32mem.mem_a
			.ddr3_32mem_mem_ba                 	( DDR3_x32_TOP_BA_o			) ,	//                     .mem_ba
			.ddr3_32mem_mem_ck                 	( DDR3_x32_TOP_CK_o			) ,	//                     .mem_ck
			.ddr3_32mem_mem_ck_n               	( DDR3_x32_TOP_CK_no		) ,	//                     .mem_ck_n
			.ddr3_32mem_mem_cke                	( DDR3_x32_TOP_CKE_o		) ,	//                     .mem_cke
			.ddr3_32mem_mem_cs_n               	( DDR3_x32_TOP_CS_no		) ,	//                     .mem_cs_n
			.ddr3_32mem_mem_dm                 	( DDR3_x32_TOP_DM_o			) ,	//                     .mem_dm
			.ddr3_32mem_mem_ras_n              	( DDR3_x32_TOP_RAS_no		) ,	//                     .mem_ras_n
			.ddr3_32mem_mem_cas_n              	( DDR3_x32_TOP_CAS_no		) ,	//                     .mem_cas_n
			.ddr3_32mem_mem_we_n               	( DDR3_x32_TOP_WE_no		) ,	//                     .mem_we_n
			.ddr3_32mem_mem_reset_n            	( DDR3_x32_TOP_RESET_no		) ,	//                     .mem_reset_n
			.ddr3_32mem_mem_dq                 	( DDR3_x32_TOP_DQ_io		) ,	//                     .mem_dq
			.ddr3_32mem_mem_dqs                	( DDR3_x32_TOP_DQS_io		) ,	//                     .mem_dqs
			.ddr3_32mem_mem_dqs_n              	( DDR3_x32_TOP_DQS_nio		) ,	//                     .mem_dqs_n
			.ddr3_32mem_mem_odt                	( DDR3_x32_TOP_ODT_o		) ,	//                     .mem_odt
			.ddr3_32oct_rzqin                  	( DDR3_x32_TOP_OCT_RZQIN_i	) ,	//           ddr3_32oct.rzqin
			.ddr3_64mem_mem_a                  	( DDR3_x64_BOT_A_o			) ,	//           ddr3_64mem.mem_a
			.ddr3_64mem_mem_ba                 	( DDR3_x64_BOT_BA_o			) ,	//                     .mem_ba
			.ddr3_64mem_mem_ck                 	( DDR3_x64_BOT_CK_o			) ,	//                     .mem_ck
			.ddr3_64mem_mem_ck_n               	( DDR3_x64_BOT_CK_no		) ,	//                     .mem_ck_n
			.ddr3_64mem_mem_cke                	( DDR3_x64_BOT_CKE_o		) ,	//                     .mem_cke
			.ddr3_64mem_mem_cs_n               	( DDR3_x64_BOT_CS_no		) ,	//                     .mem_cs_n
			.ddr3_64mem_mem_dm                 	( DDR3_x64_BOT_DM_o			) ,	//                     .mem_dm
			.ddr3_64mem_mem_ras_n              	( DDR3_x64_BOT_RAS_no		) ,	//                     .mem_ras_n
			.ddr3_64mem_mem_cas_n              	( DDR3_x64_BOT_CAS_no		) ,	//                     .mem_cas_n
			.ddr3_64mem_mem_we_n               	( DDR3_x64_BOT_WE_no		) ,	//                     .mem_we_n
			.ddr3_64mem_mem_reset_n            	( DDR3_x64_BOT_RESET_no		) ,	//                     .mem_reset_n
			.ddr3_64mem_mem_dq                 	( DDR3_x64_BOT_DQ_io		) ,	//                     .mem_dq
			.ddr3_64mem_mem_dqs                	( DDR3_x64_BOT_DQS_io		) ,	//                     .mem_dqs
			.ddr3_64mem_mem_dqs_n              	( DDR3_x64_BOT_DQS_nio		) ,	//                     .mem_dqs_n
			.ddr3_64mem_mem_odt                	( DDR3_x64_BOT_ODT_o		) ,	//                     .mem_odt
			.ddr3_64oct_rzqin                  	( DDR3_x64_BOT_OCT_RZQIN_i	) ,	//           ddr3_64oct.rzqin
			.ddr3_32status_local_init_done     	( 							) ,	//        ddr3_32status.local_init_done
			.ddr3_32status_local_cal_success   	( 							) ,	//                     .local_cal_success
			.ddr3_32status_local_cal_fail      	( 							) ,	//                     .local_cal_fail
			.ddr3_64status_local_init_done     	( 							) ,	//        ddr3_64status.local_init_done
			.ddr3_64status_local_cal_success   	( 							) ,	//                     .local_cal_success
			.ddr3_64status_local_cal_fail      	( 							) ,	//                     .local_cal_fail

			.vip_cti_video_vid_clk             	( HD_BCK_i					) ,	//        vip_cti_video.vid_clk
			.vip_cti_video_vid_data            	( hd_yuv					) ,	//                     .vid_data
			.vip_cti_video_overflow            	( 							) ,	//                     .overflow
			.vip_cti_video_vid_datavalid       	( HD_BDEN_i					) ,	//                     .vid_datavalid
			.vip_cti_video_vid_locked          	( 1'b1						) ,	//                     .vid_locked
			.vip_cti_video_vid_v_sync          	( HD_BVD_i					) ,	//                     .vid_v_sync
			.vip_cti_video_vid_h_sync          	( HD_BHD_i					) ,	//                     .vid_h_sync
			.vip_cti_video_vid_f               	( 1'b0						) ,	//                     .vid_f

			.vip_itc_video_out_vid_clk         	( video_out_vid_clk			) ,	//    vip_itc_video_out.vid_clk
			.vip_itc_video_out_vid_data        	( video_out_vid_data		) ,	//                     .vid_data
			.vip_itc_video_out_underflow       	( video_out_underflow		) ,	//                     .underflow
			.vip_itc_video_out_vid_datavalid   	( video_out_vid_datavalid	) ,	//                     .vid_datavalid
			.vip_itc_video_out_vid_v_sync      	( video_out_vid_v_sync		) ,	//                     .vid_v_sync
			.vip_itc_video_out_vid_h_sync      	( video_out_vid_h_sync		) ,	//                     .vid_h_sync
			.vip_itc_video_out_vid_f           	( video_out_vid_f			) ,	//                     .vid_f
			.vip_itc_video_out_vid_h           	( video_out_vid_h			) ,	//                     .vid_h
			.vip_itc_video_out_vid_v           	( video_out_vid_v			) ,	//                     .vid_v

			.tse_mac_mdio_mdc                  	( ENET_MDC_o				) ,	//         tse_mac_mdio.mdc
			.tse_mac_mdio_mdio_in              	( ENET_MDIO_io				) ,	//                     .mdio_in
			.tse_mac_mdio_mdio_out             	( enet_mdio_out				) ,	//                     .mdio_out
			.tse_mac_mdio_mdio_oen             	( enet_mdio_oen				) ,	//                     .mdio_oen
			.tse_mac_pcs_tx_clock_clk          	( enet_tx_clk				) ,	// tse_mac_pcs_tx_clock.clk
			.tse_mac_pcs_rx_clock_clk          	( enet_rx_clk				) ,	// tse_mac_pcs_rx_clock.clk
			.tse_mac_rgmii_rgmii_in            	( ENET_RGMII_RXD_i			) ,	//        tse_mac_rgmii.rgmii_in
			.tse_mac_rgmii_rgmii_out           	( ENET_RGMII_TXD_o			) ,	//                     .rgmii_out
			.tse_mac_rgmii_rx_control          	( ENET_RGMII_RX_DV_i		) ,	//                     .rx_control
			.tse_mac_rgmii_tx_control          	( ENET_RGMII_TX_EN_o		) ,	//                     .tx_control
			.tse_mac_status_set_10             	( mac_status_set_10			) ,	//       tse_mac_status.set_10
			.tse_mac_status_set_1000           	( mac_status_set_1000		) ,	//                     .set_1000
			.tse_mac_status_eth_mode           	( mac_status_eth_mode		) ,	//                     .eth_mode
			.tse_mac_status_ena_10             	( mac_status_ena_10			) ,	//                     .ena_10
			.tse_mac_misc_ff_tx_crc_fwd        	( 							) ,	//         tse_mac_misc.ff_tx_crc_fwd
			.tse_mac_misc_ff_tx_septy          	( 							) ,	//                     .ff_tx_septy
			.tse_mac_misc_tx_ff_uflow          	( mac_misc_tx_ff_uflow		) ,	//                     .tx_ff_uflow
			.tse_mac_misc_ff_tx_a_full         	( mac_misc_ff_tx_a_full		) ,	//                     .ff_tx_a_full
			.tse_mac_misc_ff_tx_a_empty        	( mac_misc_ff_tx_a_empty	) ,	//                     .ff_tx_a_empty
			.tse_mac_misc_rx_err_stat          	( 							) ,	//                     .rx_err_stat
			.tse_mac_misc_rx_frm_type          	( 							) ,	//                     .rx_frm_type
			.tse_mac_misc_ff_rx_dsav           	( 							) ,	//                     .ff_rx_dsav
			.tse_mac_misc_ff_rx_a_full         	( 							) ,	//                     .ff_rx_a_full
			.tse_mac_misc_ff_rx_a_empty        	( 							) ,	//                     .ff_rx_a_empty

			.dp_xcvr_mgmt_clk_clk              	( xcvr_pll_refclk			) ,	//     dp_xcvr_mgmt_clk.clk
			.dp_tx_reconfig_link_rate          	( tx_link_rate				) ,	//       dp_tx_reconfig.link_rate
			.dp_tx_reconfig_reconfig_req       	( tx_reconfig_req			) ,	//                     .reconfig_req
			.dp_tx_reconfig_reconfig_ack       	( tx_reconfig_ack			) ,	//                     .reconfig_ack
			.dp_tx_reconfig_reconfig_busy      	( tx_reconfig_busy			) ,	//                     .reconfig_busy
			.dp_tx_xcvr_interface_parallel_data	( tx_parallel_data			) ,	// dp_tx_xcvr_interface.parallel_data
			.dp_tx_xcvr_interface_pll_powerdown	( tx_pll_powerdown			) ,	//                     .pll_powerdown
			.dp_tx_xcvr_interface_analogreset  	( tx_analogreset			) ,	//                     .analogreset
			.dp_tx_xcvr_interface_digitalreset 	( tx_digitalreset			) ,	//                     .digitalreset
			.dp_tx_xcvr_interface_cal_busy     	( tx_cal_busy				) ,	//                     .cal_busy
			.dp_tx_xcvr_interface_std_clkout   	( tx_std_clkout				) ,	//                     .std_clkout
			.dp_tx_xcvr_interface_pll_locked   	( tx_pll_locked				) ,	//                     .pll_locked
			.dp_tx_vid_clk_clk                 	( video_out_vid_clk			) ,	//        dp_tx_vid_clk.clk
			.dp_tx_video_in_data               	( video_out_vid_data		) ,	//       dp_tx_video_in.data
			.dp_tx_video_in_v_sync             	( video_out_vid_v_sync		) ,	//                     .v_sync
			.dp_tx_video_in_h_sync             	( video_out_vid_h_sync		) ,	//                     .h_sync
			.dp_tx_video_in_f                  	( video_out_vid_f			) ,	//                     .f
			.dp_tx_video_in_de                 	( video_out_vid_datavalid	) ,	//                     .de
			.dp_tx_aux_aux_in                  	( DP_AUX_D_i				) ,	//            dp_tx_aux.aux_in
			.dp_tx_aux_aux_out                 	( DP_AUX_D_o				) ,	//                     .aux_out
			.dp_tx_aux_aux_oe                  	( DP_AUX_DIR_o				) ,	//                     .aux_oe
			.dp_tx_aux_hpd                     	( DP_HPD_i					) ,	//                     .hpd
		);


endmodule
`default_nettype wire

